<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 6.3: Arrays of Structures</title>
<link href="sx9b.html" rev=precedes>
<link href="sx9d.html" rel=precedes>
<link href="sx9.html" rev=subdocument>
</head>
<body>
<H2>section 6.3: Arrays of Structures</H2>

page 132
<p>In the previous section we introduced pointers to structures
and functions returning structures
without fanfare.
But now let's pay attention to the fact that structures fit 
the pattern of the other types:
a structure is a type, so we can have pointer-to-struct,
array-of-struct,
and function-returning-struct.
(We can also say,
following
our ongoing pattern
of recursive definitions,
that for any list of types <I>t1</I>, <I>t2</I>, <I>t3</I>, ...,
we can make a new type
<pre>	struct tag {
		<I>t1</I> m1;
		<I>t2</I> m2;
		<I>t3</I> m3;
		...
	};
</pre>which is a structure composed of members of those types.)
</p><p>page 134
</p><p>We glossed over the binary search routine
on page 58 in section 3.3,
so we can skip the details of this one, too.
This illustrates another benefit of breaking functionality out into functions,
though:
as long as you know what a function does,
you can understand a program
that it's in without necessarily 
understanding all of it.
In this case,
<TT>binsearch</TT> searches an array <TT>tab</TT>,
containing <TT>n</TT> cells of type <TT>struct key</TT>,
looking for one whose <TT>word</TT> field matches the parameter <TT>word</TT>.
If it finds a matching cell,
it returns its index in the array;
otherwise, it returns -1.
</p><hr>
<p>
Read sequentially:
<a href="sx9b.html" rev=precedes>prev</a>
<a href="sx9d.html" rel=precedes>next</a>
<a href="sx9.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
